/* window.c generated by valac 0.56.17, the Vala compiler
 * generated from window.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014, 2020 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include "libsudoku.h"
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <string.h>
#include <stdlib.h>

#define SUDOKU_WINDOW_small_window_width 600
#define SUDOKU_WINDOW_smallest_possible_width 360
#define SUDOKU_WINDOW_margin_default_size 25
#define SUDOKU_WINDOW_margin_small_size 10
#define SUDOKU_WINDOW_margin_size_diff (SUDOKU_WINDOW_margin_default_size - SUDOKU_WINDOW_margin_small_size)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_WINDOW (sudoku_window_get_type ())
#define SUDOKU_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_WINDOW, SudokuWindow))
#define SUDOKU_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_WINDOW, SudokuWindowClass))
#define IS_SUDOKU_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_WINDOW))
#define IS_SUDOKU_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_WINDOW))
#define SUDOKU_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_WINDOW, SudokuWindowClass))

typedef struct _SudokuWindow SudokuWindow;
typedef struct _SudokuWindowClass SudokuWindowClass;
typedef struct _SudokuWindowPrivate SudokuWindowPrivate;

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
typedef enum  {
	SUDOKU_WINDOW_SCREEN_NONE,
	SUDOKU_WINDOW_SCREEN_PLAY,
	SUDOKU_WINDOW_SCREEN_CREATE,
	SUDOKU_WINDOW_SCREEN_MENU
} SudokuWindowScreen;

#define TYPE_SUDOKU_WINDOW_SCREEN (sudoku_window_screen_get_type ())
enum  {
	SUDOKU_WINDOW_0_PROPERTY,
	SUDOKU_WINDOW_SETTINGS_PROPERTY,
	SUDOKU_WINDOW_VIEW_PROPERTY,
	SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY,
	SUDOKU_WINDOW_SHOW_TIMER_PROPERTY,
	SUDOKU_WINDOW_NUM_PROPERTIES
};
static GParamSpec* sudoku_window_properties[SUDOKU_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SudokuWindow {
	AdwApplicationWindow parent_instance;
	SudokuWindowPrivate * priv;
};

struct _SudokuWindowClass {
	AdwApplicationWindowClass parent_class;
};

struct _SudokuWindowPrivate {
	AdwWindowTitle* windowtitle;
	AdwHeaderBar* headerbar;
	GtkBox* game_box;
	GtkBox* start_box;
	GtkButton* start_button;
	GtkCheckButton* custom_check;
	GtkCheckButton* easy_check;
	GtkCheckButton* medium_check;
	GtkCheckButton* hard_check;
	GtkCheckButton* very_hard_check;
	GtkMenuButton* main_menu;
	GtkToggleButton* earmark_mode_button;
	GtkButton* undo_button;
	GtkButton* redo_button;
	GtkButton* back_button;
	GtkButton* unfullscreen_button;
	GtkButton* play_custom_game_button;
	GtkButton* play_pause_button;
	GtkButton* toggle_fullscreen_button;
	GtkBox* clock_box;
	GtkLabel* clock_label;
	gboolean window_is_maximized;
	gboolean window_is_fullscreen;
	gint window_width;
	gint window_height;
	gint small_window_height;
	gint smallest_possible_height;
	gboolean window_width_is_small;
	gboolean window_height_is_small;
	SudokuGame* game;
	GtkGestureClick* button_controller;
	GtkGestureClick* backwards_controller;
	GtkGestureClick* forwards_controller;
	GtkEventControllerScroll* scroll_controller;
	GSettings* _settings;
	SudokuView* _view;
	SudokuWindowScreen _current_screen;
	gboolean _show_timer;
};

static gint SudokuWindow_private_offset;
static gpointer sudoku_window_parent_class = NULL;

VALA_EXTERN GType sudoku_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuWindow, g_object_unref)
VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
VALA_EXTERN GType sudoku_window_screen_get_type (void) G_GNUC_CONST ;
VALA_EXTERN SudokuWindow* sudoku_window_new (GSettings* settings);
VALA_EXTERN SudokuWindow* sudoku_window_construct (GType object_type,
                                       GSettings* settings);
static void sudoku_window_set_settings (SudokuWindow* self,
                                 GSettings* value);
static void sudoku_window_construct_window_parameters (SudokuWindow* self);
static void __lambda6_ (SudokuWindow* self);
static void ___lambda6__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void __lambda7_ (SudokuWindow* self);
static void ___lambda7__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void __lambda8_ (SudokuWindow* self);
VALA_EXTERN SudokuView* sudoku_window_get_view (SudokuWindow* self);
VALA_EXTERN void sudoku_view_set_has_selection (SudokuView* self,
                                    gboolean value);
static void ___lambda8__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void sudoku_window_set_gamebox_width_margins (SudokuWindow* self,
                                              gint width);
static void sudoku_window_set_gamebox_height_margins (SudokuWindow* self,
                                               gint height);
static void sudoku_window_button_released_cb (SudokuWindow* self,
                                       GtkGestureClick* gesture,
                                       gint n_press,
                                       gdouble x,
                                       gdouble y);
static void _sudoku_window_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                   gint n_press,
                                                                   gdouble x,
                                                                   gdouble y,
                                                                   gpointer self);
static void sudoku_window_backwards_pressed_cb (SudokuWindow* self,
                                         GtkGestureClick* gesture,
                                         gint n_press,
                                         gdouble x,
                                         gdouble y);
static void _sudoku_window_backwards_pressed_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                    gint n_press,
                                                                    gdouble x,
                                                                    gdouble y,
                                                                    gpointer self);
static void sudoku_window_forwards_pressed_cb (SudokuWindow* self,
                                        GtkGestureClick* gesture,
                                        gint n_press,
                                        gdouble x,
                                        gdouble y);
static void _sudoku_window_forwards_pressed_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                   gint n_press,
                                                                   gdouble x,
                                                                   gdouble y,
                                                                   gpointer self);
static gboolean sudoku_window_scroll_cb (SudokuWindow* self,
                                  GtkEventControllerScroll* event,
                                  gdouble dx,
                                  gdouble dy);
static gboolean _sudoku_window_scroll_cb_gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                                      gdouble dx,
                                                                      gdouble dy,
                                                                      gpointer self);
static void sudoku_window_scroll_begin_cb (SudokuWindow* self,
                                    GtkEventControllerScroll* event);
static void _sudoku_window_scroll_begin_cb_gtk_event_controller_scroll_scroll_begin (GtkEventControllerScroll* _sender,
                                                                              gpointer self);
static void sudoku_window_scroll_end_cb (SudokuWindow* self,
                                  GtkEventControllerScroll* event);
static void _sudoku_window_scroll_end_cb_gtk_event_controller_scroll_scroll_end (GtkEventControllerScroll* _sender,
                                                                          gpointer self);
static gboolean sudoku_window_close_cb (SudokuWindow* self);
static gboolean _sudoku_window_close_cb_gtk_window_close_request (GtkWindow* _sender,
                                                           gpointer self);
VALA_EXTERN GSettings* sudoku_window_get_settings (SudokuWindow* self);
VALA_EXTERN void sudoku_window_set_show_timer (SudokuWindow* self,
                                   gboolean value);
static void sudoku_window_start_game_cb (SudokuWindow* self,
                                  GtkButton* btn);
static gboolean* _bool_dup (gboolean* self);
static void _sudoku_window_start_game_cb_gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self);
static void sudoku_window_window_width_is_big_cb (SudokuWindow* self);
VALA_EXTERN SudokuWindowScreen sudoku_window_get_current_screen (SudokuWindow* self);
VALA_EXTERN gboolean sudoku_window_get_show_timer (SudokuWindow* self);
static void sudoku_window_window_width_is_small_cb (SudokuWindow* self);
VALA_EXTERN void sudoku_window_will_start_game (SudokuWindow* self);
VALA_EXTERN void sudoku_window_start_game (SudokuWindow* self,
                               SudokuGame* game);
static void sudoku_window_tick_cb (SudokuWindow* self);
static void _sudoku_window_tick_cb_sudoku_game_tick (SudokuGame* _sender,
                                              gpointer self);
VALA_EXTERN void sudoku_window_show_game_view (SudokuWindow* self);
VALA_EXTERN SudokuView* sudoku_view_new (SudokuGame* game,
                             GSettings* settings);
VALA_EXTERN SudokuView* sudoku_view_construct (GType object_type,
                                   SudokuGame* game,
                                   GSettings* settings);
static void sudoku_window_set_view (SudokuWindow* self,
                             SudokuView* value);
VALA_EXTERN void sudoku_window_show_menu_screen (SudokuWindow* self);
static void sudoku_window_set_current_screen (SudokuWindow* self,
                                       SudokuWindowScreen value);
VALA_EXTERN void sudoku_window_set_board_visible (SudokuWindow* self,
                                      gboolean visible);
VALA_EXTERN void sudoku_window_activate_difficulty_checkbutton (SudokuWindow* self,
                                                    DifficultyCategory difficulty);
VALA_EXTERN gboolean sudoku_window_is_board_visible (SudokuWindow* self);
VALA_EXTERN void sudoku_window_display_pause_button (SudokuWindow* self);
VALA_EXTERN void sudoku_window_board_completed (SudokuWindow* self);
VALA_EXTERN void sudoku_view_dismiss_picker (SudokuView* self);
static gdouble sudoku_window_normalize (SudokuWindow* self,
                                 gint val,
                                 gint min,
                                 gint max);
static void sudoku_window_real_size_allocate (GtkWidget* base,
                                       gint width,
                                       gint height,
                                       gint baseline);
static void sudoku_window_real_dispose (GObject* base);
static void sudoku_window_finalize (GObject * obj);
static GType sudoku_window_get_type_once (void);
static void _vala_sudoku_window_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_sudoku_window_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);

static inline gpointer
sudoku_window_get_instance_private (SudokuWindow* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuWindow_private_offset);
}

static void
__lambda6_ (SudokuWindow* self)
{
#line 88 "../src/window.vala"
	self->priv->window_is_maximized = !self->priv->window_is_maximized;
#line 306 "window.c"
}

static void
___lambda6__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 87 "../src/window.vala"
	__lambda6_ ((SudokuWindow*) self);
#line 316 "window.c"
}

static void
__lambda7_ (SudokuWindow* self)
{
#line 92 "../src/window.vala"
	self->priv->window_is_fullscreen = !self->priv->window_is_fullscreen;
#line 93 "../src/window.vala"
	if (self->priv->window_is_fullscreen) {
#line 326 "window.c"
		AdwHeaderBar* _tmp0_;
		GtkButton* _tmp1_;
		GtkButton* _tmp2_;
		GtkButton* _tmp3_;
#line 95 "../src/window.vala"
		_tmp0_ = self->priv->headerbar;
#line 95 "../src/window.vala"
		adw_header_bar_set_decoration_layout (_tmp0_, ":close");
#line 96 "../src/window.vala"
		_tmp1_ = self->priv->toggle_fullscreen_button;
#line 96 "../src/window.vala"
		gtk_button_set_icon_name (_tmp1_, "view-restore-symbolic");
#line 97 "../src/window.vala"
		_tmp2_ = self->priv->toggle_fullscreen_button;
#line 97 "../src/window.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp2_, _ ("Leave Fullscreen"));
#line 98 "../src/window.vala"
		_tmp3_ = self->priv->unfullscreen_button;
#line 98 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp3_, TRUE);
#line 347 "window.c"
	} else {
		AdwHeaderBar* _tmp4_;
		GtkButton* _tmp5_;
		GtkButton* _tmp6_;
		GtkButton* _tmp7_;
#line 102 "../src/window.vala"
		_tmp4_ = self->priv->headerbar;
#line 102 "../src/window.vala"
		adw_header_bar_set_decoration_layout (_tmp4_, NULL);
#line 103 "../src/window.vala"
		_tmp5_ = self->priv->toggle_fullscreen_button;
#line 103 "../src/window.vala"
		gtk_button_set_icon_name (_tmp5_, "view-fullscreen-symbolic");
#line 104 "../src/window.vala"
		_tmp6_ = self->priv->toggle_fullscreen_button;
#line 104 "../src/window.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp6_, _ ("Fullscreen"));
#line 105 "../src/window.vala"
		_tmp7_ = self->priv->unfullscreen_button;
#line 105 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp7_, FALSE);
#line 106 "../src/window.vala"
		if (self->priv->window_is_maximized) {
#line 108 "../src/window.vala"
			gtk_window_maximize ((GtkWindow*) self);
#line 109 "../src/window.vala"
			return;
#line 375 "window.c"
		}
	}
}

static void
___lambda7__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 91 "../src/window.vala"
	__lambda7_ ((SudokuWindow*) self);
#line 387 "window.c"
}

static void
__lambda8_ (SudokuWindow* self)
{
	SudokuView* _tmp0_;
#line 115 "../src/window.vala"
	_tmp0_ = self->priv->_view;
#line 115 "../src/window.vala"
	if (_tmp0_ != NULL) {
#line 398 "window.c"
		SudokuView* _tmp1_;
		GtkMenuButton* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 116 "../src/window.vala"
		_tmp1_ = self->priv->_view;
#line 116 "../src/window.vala"
		_tmp2_ = self->priv->main_menu;
#line 116 "../src/window.vala"
		_tmp3_ = gtk_menu_button_get_active (_tmp2_);
#line 116 "../src/window.vala"
		_tmp4_ = _tmp3_;
#line 116 "../src/window.vala"
		sudoku_view_set_has_selection (_tmp1_, !_tmp4_);
#line 413 "window.c"
	}
}

static void
___lambda8__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 114 "../src/window.vala"
	__lambda8_ ((SudokuWindow*) self);
#line 424 "window.c"
}

static void
_sudoku_window_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                              gint n_press,
                                                              gdouble x,
                                                              gdouble y,
                                                              gpointer self)
{
#line 131 "../src/window.vala"
	sudoku_window_button_released_cb ((SudokuWindow*) self, _sender, n_press, x, y);
#line 436 "window.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 132 "../src/window.vala"
	return self ? g_object_ref (self) : NULL;
#line 444 "window.c"
}

static void
_sudoku_window_backwards_pressed_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                               gint n_press,
                                                               gdouble x,
                                                               gdouble y,
                                                               gpointer self)
{
#line 136 "../src/window.vala"
	sudoku_window_backwards_pressed_cb ((SudokuWindow*) self, _sender, n_press, x, y);
#line 456 "window.c"
}

static void
_sudoku_window_forwards_pressed_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                              gint n_press,
                                                              gdouble x,
                                                              gdouble y,
                                                              gpointer self)
{
#line 142 "../src/window.vala"
	sudoku_window_forwards_pressed_cb ((SudokuWindow*) self, _sender, n_press, x, y);
#line 468 "window.c"
}

static gboolean
_sudoku_window_scroll_cb_gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                             gdouble dx,
                                                             gdouble dy,
                                                             gpointer self)
{
	gboolean result;
	result = sudoku_window_scroll_cb ((SudokuWindow*) self, _sender, dx, dy);
#line 147 "../src/window.vala"
	return result;
#line 481 "window.c"
}

static void
_sudoku_window_scroll_begin_cb_gtk_event_controller_scroll_scroll_begin (GtkEventControllerScroll* _sender,
                                                                         gpointer self)
{
#line 148 "../src/window.vala"
	sudoku_window_scroll_begin_cb ((SudokuWindow*) self, _sender);
#line 490 "window.c"
}

static void
_sudoku_window_scroll_end_cb_gtk_event_controller_scroll_scroll_end (GtkEventControllerScroll* _sender,
                                                                     gpointer self)
{
#line 149 "../src/window.vala"
	sudoku_window_scroll_end_cb ((SudokuWindow*) self, _sender);
#line 499 "window.c"
}

static gboolean
_sudoku_window_close_cb_gtk_window_close_request (GtkWindow* _sender,
                                                  gpointer self)
{
	gboolean result;
	result = sudoku_window_close_cb ((SudokuWindow*) self);
#line 153 "../src/window.vala"
	return result;
#line 510 "window.c"
}

SudokuWindow*
sudoku_window_construct (GType object_type,
                         GSettings* settings)
{
	SudokuWindow * self = NULL;
	GtkMenuButton* _tmp0_;
	GtkGestureClick* _tmp1_;
	GtkGestureClick* _tmp2_;
	GtkGestureClick* _tmp3_;
	GtkGestureClick* _tmp4_;
	GtkEventController* _tmp5_;
	GtkGestureClick* _tmp6_;
	GtkGestureClick* _tmp7_;
	GtkGestureClick* _tmp8_;
	GtkGestureClick* _tmp9_;
	GtkGestureClick* _tmp10_;
	GtkEventController* _tmp11_;
	GtkGestureClick* _tmp12_;
	GtkGestureClick* _tmp13_;
	GtkGestureClick* _tmp14_;
	GtkGestureClick* _tmp15_;
	GtkGestureClick* _tmp16_;
	GtkEventController* _tmp17_;
	GtkEventControllerScroll* _tmp18_;
	GtkEventControllerScroll* _tmp19_;
	GtkEventControllerScroll* _tmp20_;
	GtkEventControllerScroll* _tmp21_;
	GtkEventControllerScroll* _tmp22_;
	GtkEventControllerScroll* _tmp23_;
	GtkEventController* _tmp24_;
#line 81 "../src/window.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 81 "../src/window.vala"
	self = (SudokuWindow*) g_object_new (object_type, NULL);
#line 83 "../src/window.vala"
	sudoku_window_set_settings (self, settings);
#line 85 "../src/window.vala"
	sudoku_window_construct_window_parameters (self);
#line 87 "../src/window.vala"
	g_signal_connect_object ((GObject*) self, "notify::maximized", (GCallback) ___lambda6__g_object_notify, self, 0);
#line 91 "../src/window.vala"
	g_signal_connect_object ((GObject*) self, "notify::fullscreened", (GCallback) ___lambda7__g_object_notify, self, 0);
#line 114 "../src/window.vala"
	_tmp0_ = self->priv->main_menu;
#line 114 "../src/window.vala"
	g_signal_connect_object ((GObject*) _tmp0_, "notify::active", (GCallback) ___lambda8__g_object_notify, self, 0);
#line 119 "../src/window.vala"
	if (self->priv->window_is_fullscreen) {
#line 120 "../src/window.vala"
		gtk_window_fullscreen ((GtkWindow*) self);
#line 563 "window.c"
	} else {
#line 121 "../src/window.vala"
		if (self->priv->window_is_maximized) {
#line 122 "../src/window.vala"
			gtk_window_maximize ((GtkWindow*) self);
#line 569 "window.c"
		} else {
#line 125 "../src/window.vala"
			sudoku_window_set_gamebox_width_margins (self, self->priv->window_width);
#line 126 "../src/window.vala"
			sudoku_window_set_gamebox_height_margins (self, self->priv->window_height);
#line 575 "window.c"
		}
	}
#line 129 "../src/window.vala"
	_tmp1_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 129 "../src/window.vala"
	_g_object_unref0 (self->priv->button_controller);
#line 129 "../src/window.vala"
	self->priv->button_controller = _tmp1_;
#line 130 "../src/window.vala"
	_tmp2_ = self->priv->button_controller;
#line 130 "../src/window.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp2_, (guint) 0);
#line 131 "../src/window.vala"
	_tmp3_ = self->priv->button_controller;
#line 131 "../src/window.vala"
	g_signal_connect_object (_tmp3_, "released", (GCallback) _sudoku_window_button_released_cb_gtk_gesture_click_released, self, 0);
#line 132 "../src/window.vala"
	_tmp4_ = self->priv->button_controller;
#line 132 "../src/window.vala"
	_tmp5_ = _g_object_ref0 ((GtkEventController*) _tmp4_);
#line 132 "../src/window.vala"
	gtk_widget_add_controller (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), _tmp5_);
#line 134 "../src/window.vala"
	_tmp6_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 134 "../src/window.vala"
	_g_object_unref0 (self->priv->backwards_controller);
#line 134 "../src/window.vala"
	self->priv->backwards_controller = _tmp6_;
#line 135 "../src/window.vala"
	_tmp7_ = self->priv->backwards_controller;
#line 135 "../src/window.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp7_, (guint) 8);
#line 136 "../src/window.vala"
	_tmp8_ = self->priv->backwards_controller;
#line 136 "../src/window.vala"
	g_signal_connect_object (_tmp8_, "pressed", (GCallback) _sudoku_window_backwards_pressed_cb_gtk_gesture_click_pressed, self, 0);
#line 137 "../src/window.vala"
	_tmp9_ = self->priv->backwards_controller;
#line 137 "../src/window.vala"
	gtk_event_controller_set_propagation_limit ((GtkEventController*) _tmp9_, GTK_LIMIT_NONE);
#line 138 "../src/window.vala"
	_tmp10_ = self->priv->backwards_controller;
#line 138 "../src/window.vala"
	_tmp11_ = _g_object_ref0 ((GtkEventController*) _tmp10_);
#line 138 "../src/window.vala"
	gtk_widget_add_controller (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), _tmp11_);
#line 140 "../src/window.vala"
	_tmp12_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 140 "../src/window.vala"
	_g_object_unref0 (self->priv->forwards_controller);
#line 140 "../src/window.vala"
	self->priv->forwards_controller = _tmp12_;
#line 141 "../src/window.vala"
	_tmp13_ = self->priv->forwards_controller;
#line 141 "../src/window.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp13_, (guint) 9);
#line 142 "../src/window.vala"
	_tmp14_ = self->priv->forwards_controller;
#line 142 "../src/window.vala"
	g_signal_connect_object (_tmp14_, "pressed", (GCallback) _sudoku_window_forwards_pressed_cb_gtk_gesture_click_pressed, self, 0);
#line 143 "../src/window.vala"
	_tmp15_ = self->priv->forwards_controller;
#line 143 "../src/window.vala"
	gtk_event_controller_set_propagation_limit ((GtkEventController*) _tmp15_, GTK_LIMIT_NONE);
#line 144 "../src/window.vala"
	_tmp16_ = self->priv->forwards_controller;
#line 144 "../src/window.vala"
	_tmp17_ = _g_object_ref0 ((GtkEventController*) _tmp16_);
#line 144 "../src/window.vala"
	gtk_widget_add_controller (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), _tmp17_);
#line 146 "../src/window.vala"
	_tmp18_ = (GtkEventControllerScroll*) gtk_event_controller_scroll_new (GTK_EVENT_CONTROLLER_SCROLL_VERTICAL);
#line 146 "../src/window.vala"
	_g_object_unref0 (self->priv->scroll_controller);
#line 146 "../src/window.vala"
	self->priv->scroll_controller = _tmp18_;
#line 147 "../src/window.vala"
	_tmp19_ = self->priv->scroll_controller;
#line 147 "../src/window.vala"
	g_signal_connect_object (_tmp19_, "scroll", (GCallback) _sudoku_window_scroll_cb_gtk_event_controller_scroll_scroll, self, 0);
#line 148 "../src/window.vala"
	_tmp20_ = self->priv->scroll_controller;
#line 148 "../src/window.vala"
	g_signal_connect_object (_tmp20_, "scroll-begin", (GCallback) _sudoku_window_scroll_begin_cb_gtk_event_controller_scroll_scroll_begin, self, 0);
#line 149 "../src/window.vala"
	_tmp21_ = self->priv->scroll_controller;
#line 149 "../src/window.vala"
	g_signal_connect_object (_tmp21_, "scroll-end", (GCallback) _sudoku_window_scroll_end_cb_gtk_event_controller_scroll_scroll_end, self, 0);
#line 150 "../src/window.vala"
	_tmp22_ = self->priv->scroll_controller;
#line 150 "../src/window.vala"
	gtk_event_controller_set_propagation_limit ((GtkEventController*) _tmp22_, GTK_LIMIT_NONE);
#line 151 "../src/window.vala"
	_tmp23_ = self->priv->scroll_controller;
#line 151 "../src/window.vala"
	_tmp24_ = _g_object_ref0 ((GtkEventController*) _tmp23_);
#line 151 "../src/window.vala"
	gtk_widget_add_controller (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), _tmp24_);
#line 153 "../src/window.vala"
	g_signal_connect_object ((GtkWindow*) self, "close-request", (GCallback) _sudoku_window_close_cb_gtk_window_close_request, self, 0);
#line 81 "../src/window.vala"
	return self;
#line 678 "window.c"
}

SudokuWindow*
sudoku_window_new (GSettings* settings)
{
#line 81 "../src/window.vala"
	return sudoku_window_construct (TYPE_SUDOKU_WINDOW, settings);
#line 686 "window.c"
}

static void
sudoku_window_construct_window_parameters (SudokuWindow* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	gint headerbar_natural_height = 0;
	AdwHeaderBar* _tmp5_;
	gint _tmp6_ = 0;
	GtkLabel* title_label = NULL;
	AdwWindowTitle* _tmp7_;
	GtkWidget* _tmp8_;
	GtkWidget* _tmp9_;
	GtkLabel* _tmp10_;
	GValue _tmp11_ = {0};
#line 184 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 186 "../src/window.vala"
	_tmp0_ = self->priv->_settings;
#line 186 "../src/window.vala"
	self->priv->window_width = g_settings_get_int (_tmp0_, "window-width");
#line 187 "../src/window.vala"
	_tmp1_ = self->priv->_settings;
#line 187 "../src/window.vala"
	self->priv->window_height = g_settings_get_int (_tmp1_, "window-height");
#line 188 "../src/window.vala"
	_tmp2_ = self->priv->_settings;
#line 188 "../src/window.vala"
	self->priv->window_is_maximized = g_settings_get_boolean (_tmp2_, "window-is-maximized");
#line 189 "../src/window.vala"
	_tmp3_ = self->priv->_settings;
#line 189 "../src/window.vala"
	self->priv->window_is_fullscreen = g_settings_get_boolean (_tmp3_, "window-is-fullscreen");
#line 190 "../src/window.vala"
	_tmp4_ = self->priv->_settings;
#line 190 "../src/window.vala"
	sudoku_window_set_show_timer (self, g_settings_get_boolean (_tmp4_, "show-timer"));
#line 193 "../src/window.vala"
	_tmp5_ = self->priv->headerbar;
#line 193 "../src/window.vala"
	gtk_widget_measure ((GtkWidget*) _tmp5_, GTK_ORIENTATION_VERTICAL, -1, NULL, &_tmp6_, NULL, NULL);
#line 193 "../src/window.vala"
	headerbar_natural_height = _tmp6_;
#line 195 "../src/window.vala"
	self->priv->small_window_height = SUDOKU_WINDOW_small_window_width + headerbar_natural_height;
#line 196 "../src/window.vala"
	self->priv->smallest_possible_height = SUDOKU_WINDOW_smallest_possible_width + headerbar_natural_height;
#line 198 "../src/window.vala"
	self->priv->window_width_is_small = self->priv->window_width <= SUDOKU_WINDOW_small_window_width;
#line 199 "../src/window.vala"
	self->priv->window_height_is_small = self->priv->window_height <= self->priv->small_window_height;
#line 201 "../src/window.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, SUDOKU_WINDOW_smallest_possible_width, self->priv->smallest_possible_height);
#line 202 "../src/window.vala"
	gtk_window_set_default_size ((GtkWindow*) self, self->priv->window_width, self->priv->window_height);
#line 204 "../src/window.vala"
	_tmp7_ = self->priv->windowtitle;
#line 204 "../src/window.vala"
	_tmp8_ = gtk_widget_get_first_child ((GtkWidget*) _tmp7_);
#line 204 "../src/window.vala"
	_tmp9_ = gtk_widget_get_first_child (_tmp8_);
#line 204 "../src/window.vala"
	_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_label_get_type (), GtkLabel));
#line 204 "../src/window.vala"
	title_label = _tmp10_;
#line 205 "../src/window.vala"
	g_value_init (&_tmp11_, G_TYPE_BOOLEAN);
#line 205 "../src/window.vala"
	g_value_set_boolean (&_tmp11_, FALSE);
#line 205 "../src/window.vala"
	g_object_set_property ((GObject*) title_label, "ellipsize", &_tmp11_);
#line 205 "../src/window.vala"
	G_IS_VALUE (&_tmp11_) ? (g_value_unset (&_tmp11_), NULL) : NULL;
#line 184 "../src/window.vala"
	_g_object_unref0 (title_label);
#line 766 "window.c"
}

static gboolean
sudoku_window_close_cb (SudokuWindow* self)
{
	GSettings* _tmp0_;
	gint default_width = 0;
	gint default_height = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	gboolean result;
#line 208 "../src/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 211 "../src/window.vala"
	_tmp0_ = self->priv->_settings;
#line 211 "../src/window.vala"
	g_settings_delay (_tmp0_);
#line 214 "../src/window.vala"
	gtk_window_get_default_size ((GtkWindow*) self, &_tmp1_, &_tmp2_);
#line 214 "../src/window.vala"
	default_width = _tmp1_;
#line 214 "../src/window.vala"
	default_height = _tmp2_;
#line 215 "../src/window.vala"
	_tmp3_ = self->priv->_settings;
#line 215 "../src/window.vala"
	g_settings_set_int (_tmp3_, "window-width", default_width);
#line 216 "../src/window.vala"
	_tmp4_ = self->priv->_settings;
#line 216 "../src/window.vala"
	g_settings_set_int (_tmp4_, "window-height", default_height);
#line 217 "../src/window.vala"
	_tmp5_ = self->priv->_settings;
#line 217 "../src/window.vala"
	g_settings_set_boolean (_tmp5_, "window-is-maximized", self->priv->window_is_maximized);
#line 218 "../src/window.vala"
	_tmp6_ = self->priv->_settings;
#line 218 "../src/window.vala"
	g_settings_set_boolean (_tmp6_, "window-is-fullscreen", self->priv->window_is_fullscreen);
#line 219 "../src/window.vala"
	_tmp7_ = self->priv->_settings;
#line 219 "../src/window.vala"
	g_settings_apply (_tmp7_);
#line 220 "../src/window.vala"
	result = GDK_EVENT_PROPAGATE;
#line 220 "../src/window.vala"
	return result;
#line 819 "window.c"
}

static gboolean*
_bool_dup (gboolean* self)
{
	gboolean* dup;
#line 227 "../src/window.vala"
	dup = g_new0 (gboolean, 1);
#line 227 "../src/window.vala"
	memcpy (dup, self, sizeof (gboolean));
#line 227 "../src/window.vala"
	return dup;
#line 832 "window.c"
}

static gpointer
__bool_dup0 (gpointer self)
{
#line 227 "../src/window.vala"
	return self ? _bool_dup (self) : NULL;
#line 840 "window.c"
}

static void
sudoku_window_start_game_cb (SudokuWindow* self,
                             GtkButton* btn)
{
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 224 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 224 "../src/window.vala"
	g_return_if_fail (btn != NULL);
#line 226 "../src/window.vala"
	_tmp0_ = self->priv->easy_check;
#line 226 "../src/window.vala"
	_tmp1_ = gtk_check_button_get_active (_tmp0_);
#line 226 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 226 "../src/window.vala"
	if (_tmp2_) {
#line 862 "window.c"
		GtkWidget* _tmp3_ = NULL;
		gboolean* _tmp4_ = NULL;
#line 227 "../src/window.vala"
		_tmp3_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
#line 227 "../src/window.vala"
		_tmp4_ = NULL;
#line 227 "../src/window.vala"
		if (_tmp3_ != NULL) {
#line 871 "window.c"
			gboolean _tmp5_;
			gboolean* _tmp6_;
#line 227 "../src/window.vala"
			_tmp5_ = gtk_widget_activate_action (_tmp3_, "app.start-game", "i", 1, NULL);
#line 227 "../src/window.vala"
			_tmp6_ = __bool_dup0 (&_tmp5_);
#line 227 "../src/window.vala"
			_g_free0 (_tmp4_);
#line 227 "../src/window.vala"
			_tmp4_ = _tmp6_;
#line 882 "window.c"
		}
#line 226 "../src/window.vala"
		_g_free0 (_tmp4_);
#line 886 "window.c"
	} else {
		GtkCheckButton* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 228 "../src/window.vala"
		_tmp7_ = self->priv->medium_check;
#line 228 "../src/window.vala"
		_tmp8_ = gtk_check_button_get_active (_tmp7_);
#line 228 "../src/window.vala"
		_tmp9_ = _tmp8_;
#line 228 "../src/window.vala"
		if (_tmp9_) {
#line 899 "window.c"
			GtkWidget* _tmp10_ = NULL;
			gboolean* _tmp11_ = NULL;
#line 229 "../src/window.vala"
			_tmp10_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
#line 229 "../src/window.vala"
			_tmp11_ = NULL;
#line 229 "../src/window.vala"
			if (_tmp10_ != NULL) {
#line 908 "window.c"
				gboolean _tmp12_;
				gboolean* _tmp13_;
#line 229 "../src/window.vala"
				_tmp12_ = gtk_widget_activate_action (_tmp10_, "app.start-game", "i", 2, NULL);
#line 229 "../src/window.vala"
				_tmp13_ = __bool_dup0 (&_tmp12_);
#line 229 "../src/window.vala"
				_g_free0 (_tmp11_);
#line 229 "../src/window.vala"
				_tmp11_ = _tmp13_;
#line 919 "window.c"
			}
#line 228 "../src/window.vala"
			_g_free0 (_tmp11_);
#line 923 "window.c"
		} else {
			GtkCheckButton* _tmp14_;
			gboolean _tmp15_;
			gboolean _tmp16_;
#line 230 "../src/window.vala"
			_tmp14_ = self->priv->hard_check;
#line 230 "../src/window.vala"
			_tmp15_ = gtk_check_button_get_active (_tmp14_);
#line 230 "../src/window.vala"
			_tmp16_ = _tmp15_;
#line 230 "../src/window.vala"
			if (_tmp16_) {
#line 936 "window.c"
				GtkWidget* _tmp17_ = NULL;
				gboolean* _tmp18_ = NULL;
#line 231 "../src/window.vala"
				_tmp17_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
#line 231 "../src/window.vala"
				_tmp18_ = NULL;
#line 231 "../src/window.vala"
				if (_tmp17_ != NULL) {
#line 945 "window.c"
					gboolean _tmp19_;
					gboolean* _tmp20_;
#line 231 "../src/window.vala"
					_tmp19_ = gtk_widget_activate_action (_tmp17_, "app.start-game", "i", 3, NULL);
#line 231 "../src/window.vala"
					_tmp20_ = __bool_dup0 (&_tmp19_);
#line 231 "../src/window.vala"
					_g_free0 (_tmp18_);
#line 231 "../src/window.vala"
					_tmp18_ = _tmp20_;
#line 956 "window.c"
				}
#line 230 "../src/window.vala"
				_g_free0 (_tmp18_);
#line 960 "window.c"
			} else {
				GtkCheckButton* _tmp21_;
				gboolean _tmp22_;
				gboolean _tmp23_;
#line 232 "../src/window.vala"
				_tmp21_ = self->priv->very_hard_check;
#line 232 "../src/window.vala"
				_tmp22_ = gtk_check_button_get_active (_tmp21_);
#line 232 "../src/window.vala"
				_tmp23_ = _tmp22_;
#line 232 "../src/window.vala"
				if (_tmp23_) {
#line 973 "window.c"
					GtkWidget* _tmp24_ = NULL;
					gboolean* _tmp25_ = NULL;
#line 233 "../src/window.vala"
					_tmp24_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
#line 233 "../src/window.vala"
					_tmp25_ = NULL;
#line 233 "../src/window.vala"
					if (_tmp24_ != NULL) {
#line 982 "window.c"
						gboolean _tmp26_;
						gboolean* _tmp27_;
#line 233 "../src/window.vala"
						_tmp26_ = gtk_widget_activate_action (_tmp24_, "app.start-game", "i", 4, NULL);
#line 233 "../src/window.vala"
						_tmp27_ = __bool_dup0 (&_tmp26_);
#line 233 "../src/window.vala"
						_g_free0 (_tmp25_);
#line 233 "../src/window.vala"
						_tmp25_ = _tmp27_;
#line 993 "window.c"
					}
#line 232 "../src/window.vala"
					_g_free0 (_tmp25_);
#line 997 "window.c"
				} else {
					GtkCheckButton* _tmp28_;
					gboolean _tmp29_;
					gboolean _tmp30_;
#line 234 "../src/window.vala"
					_tmp28_ = self->priv->custom_check;
#line 234 "../src/window.vala"
					_tmp29_ = gtk_check_button_get_active (_tmp28_);
#line 234 "../src/window.vala"
					_tmp30_ = _tmp29_;
#line 234 "../src/window.vala"
					if (_tmp30_) {
#line 1010 "window.c"
						GtkWidget* _tmp31_ = NULL;
						gboolean* _tmp32_ = NULL;
#line 235 "../src/window.vala"
						_tmp31_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
#line 235 "../src/window.vala"
						_tmp32_ = NULL;
#line 235 "../src/window.vala"
						if (_tmp31_ != NULL) {
#line 1019 "window.c"
							gboolean _tmp33_;
							gboolean* _tmp34_;
#line 235 "../src/window.vala"
							_tmp33_ = gtk_widget_activate_action (_tmp31_, "app.start-game", "i", 5, NULL);
#line 235 "../src/window.vala"
							_tmp34_ = __bool_dup0 (&_tmp33_);
#line 235 "../src/window.vala"
							_g_free0 (_tmp32_);
#line 235 "../src/window.vala"
							_tmp32_ = _tmp34_;
#line 1030 "window.c"
						}
#line 234 "../src/window.vala"
						_g_free0 (_tmp32_);
#line 1034 "window.c"
					}
				}
			}
		}
	}
}

static void
_sudoku_window_start_game_cb_gtk_button_clicked (GtkButton* _sender,
                                                 gpointer self)
{
#line 26 "../src/window.vala"
	sudoku_window_start_game_cb ((SudokuWindow*) self, _sender);
#line 1048 "window.c"
}

static void
sudoku_window_window_width_is_big_cb (SudokuWindow* self)
{
	SudokuWindowScreen _tmp0_;
#line 238 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 240 "../src/window.vala"
	self->priv->window_width_is_small = FALSE;
#line 241 "../src/window.vala"
	_tmp0_ = self->priv->_current_screen;
#line 241 "../src/window.vala"
	if (_tmp0_ == SUDOKU_WINDOW_SCREEN_PLAY) {
#line 1063 "window.c"
		GtkBox* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
		GtkToggleButton* _tmp4_;
#line 243 "../src/window.vala"
		_tmp1_ = self->priv->clock_box;
#line 243 "../src/window.vala"
		_tmp2_ = sudoku_window_get_show_timer (self);
#line 243 "../src/window.vala"
		_tmp3_ = _tmp2_;
#line 243 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, _tmp3_);
#line 244 "../src/window.vala"
		_tmp4_ = self->priv->earmark_mode_button;
#line 244 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp4_, TRUE);
#line 1080 "window.c"
	}
}

static void
sudoku_window_window_width_is_small_cb (SudokuWindow* self)
{
	GtkBox* _tmp0_;
	SudokuWindowScreen _tmp1_;
#line 248 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 250 "../src/window.vala"
	self->priv->window_width_is_small = TRUE;
#line 251 "../src/window.vala"
	_tmp0_ = self->priv->clock_box;
#line 251 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, FALSE);
#line 252 "../src/window.vala"
	_tmp1_ = self->priv->_current_screen;
#line 252 "../src/window.vala"
	if (_tmp1_ == SUDOKU_WINDOW_SCREEN_PLAY) {
#line 1101 "window.c"
		GtkToggleButton* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 253 "../src/window.vala"
		_tmp2_ = self->priv->earmark_mode_button;
#line 253 "../src/window.vala"
		_tmp3_ = sudoku_window_get_show_timer (self);
#line 253 "../src/window.vala"
		_tmp4_ = _tmp3_;
#line 253 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, !_tmp4_);
#line 1113 "window.c"
	}
}

void
sudoku_window_will_start_game (SudokuWindow* self)
{
	GtkButton* _tmp0_;
#line 284 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 286 "../src/window.vala"
	_tmp0_ = self->priv->back_button;
#line 286 "../src/window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
#line 1127 "window.c"
}

static void
_sudoku_window_tick_cb_sudoku_game_tick (SudokuGame* _sender,
                                         gpointer self)
{
#line 292 "../src/window.vala"
	sudoku_window_tick_cb ((SudokuWindow*) self);
#line 1136 "window.c"
}

void
sudoku_window_start_game (SudokuWindow* self,
                          SudokuGame* game)
{
	SudokuGame* _tmp0_;
	SudokuView* _tmp1_;
	GSettings* _tmp4_;
	SudokuView* _tmp5_;
	SudokuView* _tmp6_;
	GtkBox* _tmp7_;
	SudokuView* _tmp8_;
	SudokuView* _tmp9_;
	GtkButton* _tmp10_;
#line 289 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 289 "../src/window.vala"
	g_return_if_fail (game != NULL);
#line 291 "../src/window.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 291 "../src/window.vala"
	_g_object_unref0 (self->priv->game);
#line 291 "../src/window.vala"
	self->priv->game = _tmp0_;
#line 292 "../src/window.vala"
	g_signal_connect_object (game, "tick", (GCallback) _sudoku_window_tick_cb_sudoku_game_tick, self, 0);
#line 293 "../src/window.vala"
	sudoku_game_start_clock (game);
#line 295 "../src/window.vala"
	_tmp1_ = self->priv->_view;
#line 295 "../src/window.vala"
	if (_tmp1_ != NULL) {
#line 1170 "window.c"
		GtkBox* _tmp2_;
		SudokuView* _tmp3_;
#line 296 "../src/window.vala"
		_tmp2_ = self->priv->game_box;
#line 296 "../src/window.vala"
		_tmp3_ = self->priv->_view;
#line 296 "../src/window.vala"
		gtk_box_remove (_tmp2_, (GtkWidget*) _tmp3_);
#line 1179 "window.c"
	}
#line 298 "../src/window.vala"
	sudoku_window_show_game_view (self);
#line 300 "../src/window.vala"
	_tmp4_ = self->priv->_settings;
#line 300 "../src/window.vala"
	_tmp5_ = sudoku_view_new (game, _tmp4_);
#line 300 "../src/window.vala"
	g_object_ref_sink (_tmp5_);
#line 300 "../src/window.vala"
	_tmp6_ = _tmp5_;
#line 300 "../src/window.vala"
	sudoku_window_set_view (self, _tmp6_);
#line 300 "../src/window.vala"
	_g_object_unref0 (_tmp6_);
#line 302 "../src/window.vala"
	_tmp7_ = self->priv->game_box;
#line 302 "../src/window.vala"
	_tmp8_ = self->priv->_view;
#line 302 "../src/window.vala"
	gtk_box_prepend (_tmp7_, (GtkWidget*) _tmp8_);
#line 303 "../src/window.vala"
	_tmp9_ = self->priv->_view;
#line 303 "../src/window.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp9_);
#line 305 "../src/window.vala"
	_tmp10_ = self->priv->back_button;
#line 305 "../src/window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, TRUE);
#line 1209 "window.c"
}

void
sudoku_window_show_menu_screen (SudokuWindow* self)
{
	AdwWindowTitle* _tmp0_;
	GtkButton* _tmp1_;
	SudokuGame* _tmp2_;
	GtkToggleButton* _tmp3_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkBox* _tmp6_;
	GtkButton* _tmp7_;
	GtkButton* _tmp8_;
#line 308 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 310 "../src/window.vala"
	sudoku_window_set_current_screen (self, SUDOKU_WINDOW_SCREEN_MENU);
#line 311 "../src/window.vala"
	_tmp0_ = self->priv->windowtitle;
#line 311 "../src/window.vala"
	adw_window_title_set_subtitle (_tmp0_, _ ("Select Difficulty"));
#line 312 "../src/window.vala"
	sudoku_window_set_board_visible (self, FALSE);
#line 313 "../src/window.vala"
	_tmp1_ = self->priv->back_button;
#line 313 "../src/window.vala"
	_tmp2_ = self->priv->game;
#line 313 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, _tmp2_ != NULL);
#line 314 "../src/window.vala"
	_tmp3_ = self->priv->earmark_mode_button;
#line 314 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
#line 315 "../src/window.vala"
	_tmp4_ = self->priv->undo_button;
#line 315 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, FALSE);
#line 316 "../src/window.vala"
	_tmp5_ = self->priv->redo_button;
#line 316 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, FALSE);
#line 317 "../src/window.vala"
	_tmp6_ = self->priv->clock_box;
#line 317 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, FALSE);
#line 318 "../src/window.vala"
	_tmp7_ = self->priv->play_pause_button;
#line 318 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp7_, FALSE);
#line 319 "../src/window.vala"
	_tmp8_ = self->priv->start_button;
#line 319 "../src/window.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp8_);
#line 1264 "window.c"
}

void
sudoku_window_activate_difficulty_checkbutton (SudokuWindow* self,
                                               DifficultyCategory difficulty)
{
#line 322 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 324 "../src/window.vala"
	switch (difficulty) {
#line 324 "../src/window.vala"
		case DIFFICULTY_CATEGORY_EASY:
#line 1277 "window.c"
		{
			GtkCheckButton* _tmp0_;
#line 327 "../src/window.vala"
			_tmp0_ = self->priv->easy_check;
#line 327 "../src/window.vala"
			g_signal_emit_by_name (_tmp0_, "activate");
#line 328 "../src/window.vala"
			return;
#line 1286 "window.c"
		}
#line 324 "../src/window.vala"
		case DIFFICULTY_CATEGORY_MEDIUM:
#line 1290 "window.c"
		{
			GtkCheckButton* _tmp1_;
#line 330 "../src/window.vala"
			_tmp1_ = self->priv->medium_check;
#line 330 "../src/window.vala"
			g_signal_emit_by_name (_tmp1_, "activate");
#line 331 "../src/window.vala"
			return;
#line 1299 "window.c"
		}
#line 324 "../src/window.vala"
		case DIFFICULTY_CATEGORY_HARD:
#line 1303 "window.c"
		{
			GtkCheckButton* _tmp2_;
#line 333 "../src/window.vala"
			_tmp2_ = self->priv->hard_check;
#line 333 "../src/window.vala"
			g_signal_emit_by_name (_tmp2_, "activate");
#line 334 "../src/window.vala"
			return;
#line 1312 "window.c"
		}
#line 324 "../src/window.vala"
		case DIFFICULTY_CATEGORY_VERY_HARD:
#line 1316 "window.c"
		{
			GtkCheckButton* _tmp3_;
#line 336 "../src/window.vala"
			_tmp3_ = self->priv->very_hard_check;
#line 336 "../src/window.vala"
			g_signal_emit_by_name (_tmp3_, "activate");
#line 337 "../src/window.vala"
			return;
#line 1325 "window.c"
		}
#line 324 "../src/window.vala"
		case DIFFICULTY_CATEGORY_CUSTOM:
#line 1329 "window.c"
		{
			GtkCheckButton* _tmp4_;
#line 339 "../src/window.vala"
			_tmp4_ = self->priv->custom_check;
#line 339 "../src/window.vala"
			g_signal_emit_by_name (_tmp4_, "activate");
#line 340 "../src/window.vala"
			return;
#line 1338 "window.c"
		}
		default:
		{
#line 342 "../src/window.vala"
			g_assert_not_reached ();
#line 1344 "window.c"
		}
	}
}

void
sudoku_window_set_board_visible (SudokuWindow* self,
                                 gboolean visible)
{
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GtkButton* _tmp6_;
#line 346 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 348 "../src/window.vala"
	_tmp0_ = self->priv->start_box;
#line 348 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, !visible);
#line 349 "../src/window.vala"
	_tmp1_ = self->priv->game_box;
#line 349 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, visible);
#line 350 "../src/window.vala"
	if (visible) {
#line 1369 "window.c"
		SudokuGame* _tmp3_;
		GameMode _tmp4_;
		GameMode _tmp5_;
#line 350 "../src/window.vala"
		_tmp3_ = self->priv->game;
#line 350 "../src/window.vala"
		_tmp4_ = sudoku_game_get_mode (_tmp3_);
#line 350 "../src/window.vala"
		_tmp5_ = _tmp4_;
#line 350 "../src/window.vala"
		_tmp2_ = _tmp5_ == GAME_MODE_CREATE;
#line 1381 "window.c"
	} else {
#line 350 "../src/window.vala"
		_tmp2_ = FALSE;
#line 1385 "window.c"
	}
#line 350 "../src/window.vala"
	_tmp6_ = self->priv->play_custom_game_button;
#line 350 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, _tmp2_);
#line 1391 "window.c"
}

gboolean
sudoku_window_is_board_visible (SudokuWindow* self)
{
	GtkBox* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 353 "../src/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 355 "../src/window.vala"
	_tmp0_ = self->priv->game_box;
#line 355 "../src/window.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 355 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 355 "../src/window.vala"
	result = _tmp2_;
#line 355 "../src/window.vala"
	return result;
#line 1413 "window.c"
}

void
sudoku_window_show_game_view (SudokuWindow* self)
{
	SudokuGame* _tmp0_;
	SudokuGame* _tmp1_;
	GameMode _tmp2_;
	GameMode _tmp3_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkButton* _tmp6_;
	SudokuGame* _tmp7_;
	GameMode _tmp8_;
	GameMode _tmp9_;
#line 358 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 358 "../src/window.vala"
	_tmp0_ = self->priv->game;
#line 358 "../src/window.vala"
	_vala_return_if_fail (_tmp0_ != NULL, "game != null");
#line 361 "../src/window.vala"
	_tmp1_ = self->priv->game;
#line 361 "../src/window.vala"
	_tmp2_ = sudoku_game_get_mode (_tmp1_);
#line 361 "../src/window.vala"
	_tmp3_ = _tmp2_;
#line 361 "../src/window.vala"
	sudoku_window_set_current_screen (self, (SudokuWindowScreen) _tmp3_);
#line 362 "../src/window.vala"
	sudoku_window_set_board_visible (self, TRUE);
#line 363 "../src/window.vala"
	_tmp4_ = self->priv->back_button;
#line 363 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, FALSE);
#line 364 "../src/window.vala"
	_tmp5_ = self->priv->undo_button;
#line 364 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, TRUE);
#line 365 "../src/window.vala"
	_tmp6_ = self->priv->redo_button;
#line 365 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, TRUE);
#line 367 "../src/window.vala"
	_tmp7_ = self->priv->game;
#line 367 "../src/window.vala"
	_tmp8_ = sudoku_game_get_mode (_tmp7_);
#line 367 "../src/window.vala"
	_tmp9_ = _tmp8_;
#line 367 "../src/window.vala"
	if (_tmp9_ == GAME_MODE_PLAY) {
#line 1465 "window.c"
		GtkButton* _tmp10_;
		gboolean _tmp11_ = FALSE;
		GtkToggleButton* _tmp14_;
		AdwWindowTitle* _tmp15_;
		SudokuGame* _tmp16_;
		SudokuBoard* _tmp17_;
		SudokuBoard* _tmp18_;
		DifficultyCategory _tmp19_;
		DifficultyCategory _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gboolean _tmp23_;
		gboolean _tmp24_;
#line 369 "../src/window.vala"
		_tmp10_ = self->priv->play_custom_game_button;
#line 369 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp10_, FALSE);
#line 370 "../src/window.vala"
		if (!self->priv->window_width_is_small) {
#line 370 "../src/window.vala"
			_tmp11_ = TRUE;
#line 1487 "window.c"
		} else {
			gboolean _tmp12_;
			gboolean _tmp13_;
#line 370 "../src/window.vala"
			_tmp12_ = sudoku_window_get_show_timer (self);
#line 370 "../src/window.vala"
			_tmp13_ = _tmp12_;
#line 370 "../src/window.vala"
			_tmp11_ = !_tmp13_;
#line 1497 "window.c"
		}
#line 370 "../src/window.vala"
		_tmp14_ = self->priv->earmark_mode_button;
#line 370 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp14_, _tmp11_);
#line 371 "../src/window.vala"
		_tmp15_ = self->priv->windowtitle;
#line 371 "../src/window.vala"
		_tmp16_ = self->priv->game;
#line 371 "../src/window.vala"
		_tmp17_ = sudoku_game_get_board (_tmp16_);
#line 371 "../src/window.vala"
		_tmp18_ = _tmp17_;
#line 371 "../src/window.vala"
		_tmp19_ = sudoku_board_get_difficulty_category (_tmp18_);
#line 371 "../src/window.vala"
		_tmp20_ = _tmp19_;
#line 371 "../src/window.vala"
		_tmp21_ = difficulty_category_to_string (_tmp20_);
#line 371 "../src/window.vala"
		_tmp22_ = _tmp21_;
#line 371 "../src/window.vala"
		adw_window_title_set_subtitle (_tmp15_, _tmp22_);
#line 371 "../src/window.vala"
		_g_free0 (_tmp22_);
#line 373 "../src/window.vala"
		_tmp23_ = sudoku_window_get_show_timer (self);
#line 373 "../src/window.vala"
		_tmp24_ = _tmp23_;
#line 373 "../src/window.vala"
		if (_tmp24_) {
#line 1529 "window.c"
			GtkBox* _tmp25_;
#line 375 "../src/window.vala"
			sudoku_window_display_pause_button (self);
#line 376 "../src/window.vala"
			_tmp25_ = self->priv->clock_box;
#line 376 "../src/window.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp25_, !self->priv->window_width_is_small);
#line 1537 "window.c"
		} else {
			GtkButton* _tmp26_;
			GtkBox* _tmp27_;
#line 380 "../src/window.vala"
			_tmp26_ = self->priv->play_pause_button;
#line 380 "../src/window.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp26_, FALSE);
#line 381 "../src/window.vala"
			_tmp27_ = self->priv->clock_box;
#line 381 "../src/window.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp27_, FALSE);
#line 1549 "window.c"
		}
	} else {
		GtkToggleButton* _tmp28_;
		GtkBox* _tmp29_;
		GtkButton* _tmp30_;
		GtkButton* _tmp31_;
		AdwWindowTitle* _tmp32_;
#line 386 "../src/window.vala"
		_tmp28_ = self->priv->earmark_mode_button;
#line 386 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp28_, FALSE);
#line 387 "../src/window.vala"
		_tmp29_ = self->priv->clock_box;
#line 387 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp29_, FALSE);
#line 388 "../src/window.vala"
		_tmp30_ = self->priv->play_custom_game_button;
#line 388 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp30_, TRUE);
#line 389 "../src/window.vala"
		_tmp31_ = self->priv->play_pause_button;
#line 389 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp31_, FALSE);
#line 390 "../src/window.vala"
		_tmp32_ = self->priv->windowtitle;
#line 390 "../src/window.vala"
		adw_window_title_set_subtitle (_tmp32_, _ ("Create Puzzle"));
#line 1577 "window.c"
	}
}

void
sudoku_window_board_completed (SudokuWindow* self)
{
	GtkButton* _tmp0_;
#line 394 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 396 "../src/window.vala"
	_tmp0_ = self->priv->play_custom_game_button;
#line 396 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, FALSE);
#line 1591 "window.c"
}

void
sudoku_window_display_pause_button (SudokuWindow* self)
{
	GtkButton* _tmp0_;
	const gchar* _tmp1_ = NULL;
	SudokuGame* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GtkButton* _tmp5_;
	const gchar* _tmp6_ = NULL;
	SudokuGame* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	GtkButton* _tmp10_;
#line 399 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 401 "../src/window.vala"
	_tmp0_ = self->priv->play_pause_button;
#line 401 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, TRUE);
#line 402 "../src/window.vala"
	_tmp2_ = self->priv->game;
#line 402 "../src/window.vala"
	_tmp3_ = sudoku_game_get_paused (_tmp2_);
#line 402 "../src/window.vala"
	_tmp4_ = _tmp3_;
#line 402 "../src/window.vala"
	if (_tmp4_) {
#line 402 "../src/window.vala"
		_tmp1_ = "media-playback-start-symbolic";
#line 1624 "window.c"
	} else {
#line 402 "../src/window.vala"
		_tmp1_ = "media-playback-pause-symbolic";
#line 1628 "window.c"
	}
#line 402 "../src/window.vala"
	_tmp5_ = self->priv->play_pause_button;
#line 402 "../src/window.vala"
	gtk_button_set_icon_name (_tmp5_, _tmp1_);
#line 403 "../src/window.vala"
	_tmp7_ = self->priv->game;
#line 403 "../src/window.vala"
	_tmp8_ = sudoku_game_get_paused (_tmp7_);
#line 403 "../src/window.vala"
	_tmp9_ = _tmp8_;
#line 403 "../src/window.vala"
	if (_tmp9_) {
#line 403 "../src/window.vala"
		_tmp6_ = _ ("Play");
#line 1644 "window.c"
	} else {
#line 403 "../src/window.vala"
		_tmp6_ = _ ("Pause");
#line 1648 "window.c"
	}
#line 403 "../src/window.vala"
	_tmp10_ = self->priv->play_pause_button;
#line 403 "../src/window.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp10_, _tmp6_);
#line 1654 "window.c"
}

static void
sudoku_window_tick_cb (SudokuWindow* self)
{
	gint elapsed_time = 0;
	SudokuGame* _tmp0_;
	gint hours = 0;
	gint minutes = 0;
	gint seconds = 0;
#line 406 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 408 "../src/window.vala"
	_tmp0_ = self->priv->game;
#line 408 "../src/window.vala"
	elapsed_time = (gint) sudoku_game_get_total_time_played (_tmp0_);
#line 409 "../src/window.vala"
	hours = elapsed_time / 3600;
#line 410 "../src/window.vala"
	minutes = (elapsed_time - (hours * 3600)) / 60;
#line 411 "../src/window.vala"
	seconds = (elapsed_time - (hours * 3600)) - (minutes * 60);
#line 412 "../src/window.vala"
	if (hours > 0) {
#line 1679 "window.c"
		GtkLabel* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 413 "../src/window.vala"
		_tmp1_ = self->priv->clock_label;
#line 413 "../src/window.vala"
		_tmp2_ = g_strdup_printf ("%02d∶\xE2\x80\x8E%02d∶\xE2\x80\x8E%02d", hours, minutes, seconds);
#line 413 "../src/window.vala"
		_tmp3_ = _tmp2_;
#line 413 "../src/window.vala"
		gtk_label_set_text (_tmp1_, _tmp3_);
#line 413 "../src/window.vala"
		_g_free0 (_tmp3_);
#line 1693 "window.c"
	} else {
		GtkLabel* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 415 "../src/window.vala"
		_tmp4_ = self->priv->clock_label;
#line 415 "../src/window.vala"
		_tmp5_ = g_strdup_printf ("%02d∶\xE2\x80\x8E%02d", minutes, seconds);
#line 415 "../src/window.vala"
		_tmp6_ = _tmp5_;
#line 415 "../src/window.vala"
		gtk_label_set_text (_tmp4_, _tmp6_);
#line 415 "../src/window.vala"
		_g_free0 (_tmp6_);
#line 1708 "window.c"
	}
}

static void
sudoku_window_button_released_cb (SudokuWindow* self,
                                  GtkGestureClick* gesture,
                                  gint n_press,
                                  gdouble x,
                                  gdouble y)
{
	gboolean _tmp0_ = FALSE;
	SudokuWindowScreen _tmp1_;
#line 418 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 418 "../src/window.vala"
	g_return_if_fail (gesture != NULL);
#line 423 "../src/window.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_PRIMARY)) {
#line 424 "../src/window.vala"
		_tmp0_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_SECONDARY);
#line 1729 "window.c"
	} else {
#line 423 "../src/window.vala"
		_tmp0_ = FALSE;
#line 1733 "window.c"
	}
#line 423 "../src/window.vala"
	if (_tmp0_) {
#line 425 "../src/window.vala"
		return;
#line 1739 "window.c"
	}
#line 427 "../src/window.vala"
	_tmp1_ = self->priv->_current_screen;
#line 427 "../src/window.vala"
	if (_tmp1_ != SUDOKU_WINDOW_SCREEN_MENU) {
#line 1745 "window.c"
		SudokuView* _tmp2_;
#line 428 "../src/window.vala"
		_tmp2_ = self->priv->_view;
#line 428 "../src/window.vala"
		sudoku_view_dismiss_picker (_tmp2_);
#line 1751 "window.c"
	}
#line 430 "../src/window.vala"
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 1755 "window.c"
}

static void
sudoku_window_backwards_pressed_cb (SudokuWindow* self,
                                    GtkGestureClick* gesture,
                                    gint n_press,
                                    gdouble x,
                                    gdouble y)
{
#line 434 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 434 "../src/window.vala"
	g_return_if_fail (gesture != NULL);
#line 439 "../src/window.vala"
	gtk_widget_activate_action (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "app.undo", NULL, NULL);
#line 440 "../src/window.vala"
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 1773 "window.c"
}

static void
sudoku_window_forwards_pressed_cb (SudokuWindow* self,
                                   GtkGestureClick* gesture,
                                   gint n_press,
                                   gdouble x,
                                   gdouble y)
{
#line 443 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 443 "../src/window.vala"
	g_return_if_fail (gesture != NULL);
#line 448 "../src/window.vala"
	gtk_widget_activate_action (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "app.redo", NULL, NULL);
#line 449 "../src/window.vala"
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 1791 "window.c"
}

static gboolean
sudoku_window_scroll_cb (SudokuWindow* self,
                         GtkEventControllerScroll* event,
                         gdouble dx,
                         gdouble dy)
{
	GdkModifierType state = 0U;
	gboolean result;
#line 452 "../src/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 452 "../src/window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 457 "../src/window.vala"
	state = gtk_event_controller_get_current_event_state ((GtkEventController*) event);
#line 458 "../src/window.vala"
	if (state == GDK_CONTROL_MASK) {
#line 460 "../src/window.vala"
		if (dy <= ((gdouble) -1)) {
#line 462 "../src/window.vala"
			gtk_widget_activate_action (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "app.zoom-in", NULL, NULL);
#line 463 "../src/window.vala"
			result = GDK_EVENT_STOP;
#line 463 "../src/window.vala"
			return result;
#line 1818 "window.c"
		} else {
#line 465 "../src/window.vala"
			if (dy >= ((gdouble) 1)) {
#line 467 "../src/window.vala"
				gtk_widget_activate_action (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "app.zoom-out", NULL, NULL);
#line 468 "../src/window.vala"
				result = GDK_EVENT_STOP;
#line 468 "../src/window.vala"
				return result;
#line 1828 "window.c"
			}
		}
	}
#line 472 "../src/window.vala"
	result = GDK_EVENT_PROPAGATE;
#line 472 "../src/window.vala"
	return result;
#line 1836 "window.c"
}

static void
sudoku_window_scroll_begin_cb (SudokuWindow* self,
                               GtkEventControllerScroll* event)
{
	GdkModifierType state = 0U;
#line 475 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 475 "../src/window.vala"
	g_return_if_fail (event != NULL);
#line 478 "../src/window.vala"
	state = gtk_event_controller_get_current_event_state ((GtkEventController*) event);
#line 479 "../src/window.vala"
	if (state == GDK_CONTROL_MASK) {
#line 481 "../src/window.vala"
		gtk_event_controller_scroll_set_flags (event, GTK_EVENT_CONTROLLER_SCROLL_VERTICAL | GTK_EVENT_CONTROLLER_SCROLL_DISCRETE);
#line 1854 "window.c"
	}
}

static void
sudoku_window_scroll_end_cb (SudokuWindow* self,
                             GtkEventControllerScroll* event)
{
#line 486 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 486 "../src/window.vala"
	g_return_if_fail (event != NULL);
#line 488 "../src/window.vala"
	gtk_event_controller_scroll_set_flags (event, GTK_EVENT_CONTROLLER_SCROLL_VERTICAL);
#line 1868 "window.c"
}

static gdouble
sudoku_window_normalize (SudokuWindow* self,
                         gint val,
                         gint min,
                         gint max)
{
	gdouble result;
#line 491 "../src/window.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 493 "../src/window.vala"
	CLAMP (val, min, max);
#line 494 "../src/window.vala"
	result = (val - min) / ((gdouble) (max - min));
#line 494 "../src/window.vala"
	return result;
#line 1886 "window.c"
}

static void
sudoku_window_set_gamebox_width_margins (SudokuWindow* self,
                                         gint width)
{
	gdouble factor = 0.0;
	gint margin_size = 0;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
#line 497 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 499 "../src/window.vala"
	factor = sudoku_window_normalize (self, width, SUDOKU_WINDOW_smallest_possible_width, SUDOKU_WINDOW_small_window_width);
#line 500 "../src/window.vala"
	margin_size = SUDOKU_WINDOW_margin_small_size + ((gint) (SUDOKU_WINDOW_margin_size_diff * factor));
#line 501 "../src/window.vala"
	_tmp0_ = self->priv->game_box;
#line 501 "../src/window.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp0_, margin_size);
#line 502 "../src/window.vala"
	_tmp1_ = self->priv->game_box;
#line 502 "../src/window.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp1_, margin_size);
#line 1911 "window.c"
}

static void
sudoku_window_set_gamebox_height_margins (SudokuWindow* self,
                                          gint height)
{
	gdouble factor = 0.0;
	gint margin_size = 0;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
#line 505 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 507 "../src/window.vala"
	factor = sudoku_window_normalize (self, height, self->priv->smallest_possible_height, self->priv->small_window_height);
#line 508 "../src/window.vala"
	margin_size = SUDOKU_WINDOW_margin_small_size + ((gint) (SUDOKU_WINDOW_margin_size_diff * factor));
#line 509 "../src/window.vala"
	_tmp0_ = self->priv->game_box;
#line 509 "../src/window.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp0_, margin_size);
#line 510 "../src/window.vala"
	_tmp1_ = self->priv->game_box;
#line 510 "../src/window.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp1_, margin_size);
#line 1936 "window.c"
}

static void
sudoku_window_real_size_allocate (GtkWidget* base,
                                  gint width,
                                  gint height,
                                  gint baseline)
{
	SudokuWindow * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 513 "../src/window.vala"
	self = (SudokuWindow*) base;
#line 515 "../src/window.vala"
	if (width < SUDOKU_WINDOW_small_window_width) {
#line 515 "../src/window.vala"
		_tmp0_ = !self->priv->window_width_is_small;
#line 1954 "window.c"
	} else {
#line 515 "../src/window.vala"
		_tmp0_ = FALSE;
#line 1958 "window.c"
	}
#line 515 "../src/window.vala"
	if (_tmp0_) {
#line 516 "../src/window.vala"
		sudoku_window_window_width_is_small_cb (self);
#line 1964 "window.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 517 "../src/window.vala"
		if (width >= SUDOKU_WINDOW_small_window_width) {
#line 517 "../src/window.vala"
			_tmp1_ = self->priv->window_width_is_small;
#line 1971 "window.c"
		} else {
#line 517 "../src/window.vala"
			_tmp1_ = FALSE;
#line 1975 "window.c"
		}
#line 517 "../src/window.vala"
		if (_tmp1_) {
#line 518 "../src/window.vala"
			sudoku_window_window_width_is_big_cb (self);
#line 1981 "window.c"
		}
	}
#line 520 "../src/window.vala"
	if (self->priv->window_width != width) {
#line 520 "../src/window.vala"
		_tmp2_ = TRUE;
#line 1988 "window.c"
	} else {
#line 520 "../src/window.vala"
		_tmp2_ = self->priv->window_height != height;
#line 1992 "window.c"
	}
#line 520 "../src/window.vala"
	if (_tmp2_) {
#line 1996 "window.c"
		GtkRequisition min_size = {0};
		GtkRequisition _tmp3_ = {0};
		GtkRequisition _tmp4_;
		GtkRequisition _tmp5_;
#line 522 "../src/window.vala"
		sudoku_window_set_gamebox_width_margins (self, width);
#line 523 "../src/window.vala"
		sudoku_window_set_gamebox_height_margins (self, height);
#line 526 "../src/window.vala"
		gtk_widget_get_preferred_size ((GtkWidget*) self, &_tmp3_, NULL);
#line 526 "../src/window.vala"
		min_size = _tmp3_;
#line 527 "../src/window.vala"
		_tmp4_ = min_size;
#line 527 "../src/window.vala"
		width = MAX (_tmp4_.width, width);
#line 527 "../src/window.vala"
		self->priv->window_width = width;
#line 528 "../src/window.vala"
		_tmp5_ = min_size;
#line 528 "../src/window.vala"
		height = MAX (_tmp5_.height, height);
#line 528 "../src/window.vala"
		self->priv->window_height = height;
#line 2021 "window.c"
	}
#line 531 "../src/window.vala"
	GTK_WIDGET_CLASS (sudoku_window_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_application_window_get_type (), AdwApplicationWindow), width, height, baseline);
#line 2025 "window.c"
}

static void
sudoku_window_real_dispose (GObject* base)
{
	SudokuWindow * self;
#line 534 "../src/window.vala"
	self = (SudokuWindow*) base;
#line 538 "../src/window.vala"
	gtk_widget_dispose_template ((GtkWidget*) self, G_TYPE_FROM_INSTANCE ((GObject*) self));
#line 539 "../src/window.vala"
	G_OBJECT_CLASS (sudoku_window_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_application_window_get_type (), AdwApplicationWindow));
#line 2038 "window.c"
}

GSettings*
sudoku_window_get_settings (SudokuWindow* self)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 77 "../src/window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 77 "../src/window.vala"
	_tmp0_ = self->priv->_settings;
#line 77 "../src/window.vala"
	result = _tmp0_;
#line 77 "../src/window.vala"
	return result;
#line 2054 "window.c"
}

static void
sudoku_window_set_settings (SudokuWindow* self,
                            GSettings* value)
{
	GSettings* old_value;
#line 77 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/window.vala"
	old_value = sudoku_window_get_settings (self);
#line 77 "../src/window.vala"
	if (old_value != value) {
#line 2068 "window.c"
		GSettings* _tmp0_;
#line 77 "../src/window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 77 "../src/window.vala"
		_g_object_unref0 (self->priv->_settings);
#line 77 "../src/window.vala"
		self->priv->_settings = _tmp0_;
#line 77 "../src/window.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_window_properties[SUDOKU_WINDOW_SETTINGS_PROPERTY]);
#line 2078 "window.c"
	}
}

SudokuView*
sudoku_window_get_view (SudokuWindow* self)
{
	SudokuView* result;
	SudokuView* _tmp0_;
#line 78 "../src/window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 78 "../src/window.vala"
	_tmp0_ = self->priv->_view;
#line 78 "../src/window.vala"
	result = _tmp0_;
#line 78 "../src/window.vala"
	return result;
#line 2095 "window.c"
}

static void
sudoku_window_set_view (SudokuWindow* self,
                        SudokuView* value)
{
	SudokuView* old_value;
#line 78 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 78 "../src/window.vala"
	old_value = sudoku_window_get_view (self);
#line 78 "../src/window.vala"
	if (old_value != value) {
#line 2109 "window.c"
		SudokuView* _tmp0_;
#line 78 "../src/window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 78 "../src/window.vala"
		_g_object_unref0 (self->priv->_view);
#line 78 "../src/window.vala"
		self->priv->_view = _tmp0_;
#line 78 "../src/window.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_window_properties[SUDOKU_WINDOW_VIEW_PROPERTY]);
#line 2119 "window.c"
	}
}

SudokuWindowScreen
sudoku_window_get_current_screen (SudokuWindow* self)
{
	SudokuWindowScreen result;
#line 79 "../src/window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 79 "../src/window.vala"
	result = self->priv->_current_screen;
#line 79 "../src/window.vala"
	return result;
#line 2133 "window.c"
}

static void
sudoku_window_set_current_screen (SudokuWindow* self,
                                  SudokuWindowScreen value)
{
	SudokuWindowScreen old_value;
#line 79 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 79 "../src/window.vala"
	old_value = sudoku_window_get_current_screen (self);
#line 79 "../src/window.vala"
	if (old_value != value) {
#line 79 "../src/window.vala"
		self->priv->_current_screen = value;
#line 79 "../src/window.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_window_properties[SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY]);
#line 2151 "window.c"
	}
}

gboolean
sudoku_window_get_show_timer (SudokuWindow* self)
{
	gboolean result;
#line 259 "../src/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 259 "../src/window.vala"
	result = self->priv->_show_timer;
#line 259 "../src/window.vala"
	return result;
#line 2165 "window.c"
}

void
sudoku_window_set_show_timer (SudokuWindow* self,
                              gboolean value)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
	SudokuWindowScreen _tmp6_;
#line 260 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 261 "../src/window.vala"
	self->priv->_show_timer = value;
#line 263 "../src/window.vala"
	_tmp1_ = self->priv->game;
#line 263 "../src/window.vala"
	if (_tmp1_ != NULL) {
#line 2183 "window.c"
		SudokuGame* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 263 "../src/window.vala"
		_tmp2_ = self->priv->game;
#line 263 "../src/window.vala"
		_tmp3_ = sudoku_game_get_paused (_tmp2_);
#line 263 "../src/window.vala"
		_tmp4_ = _tmp3_;
#line 263 "../src/window.vala"
		_tmp0_ = _tmp4_;
#line 2195 "window.c"
	} else {
#line 263 "../src/window.vala"
		_tmp0_ = FALSE;
#line 2199 "window.c"
	}
#line 263 "../src/window.vala"
	if (_tmp0_) {
#line 2203 "window.c"
		SudokuGame* _tmp5_;
#line 264 "../src/window.vala"
		_tmp5_ = self->priv->game;
#line 264 "../src/window.vala"
		sudoku_game_set_paused (_tmp5_, FALSE);
#line 2209 "window.c"
	}
#line 266 "../src/window.vala"
	_tmp6_ = self->priv->_current_screen;
#line 266 "../src/window.vala"
	if (_tmp6_ == SUDOKU_WINDOW_SCREEN_PLAY) {
#line 2215 "window.c"
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 268 "../src/window.vala"
		_tmp7_ = sudoku_window_get_show_timer (self);
#line 268 "../src/window.vala"
		_tmp8_ = _tmp7_;
#line 268 "../src/window.vala"
		if (_tmp8_) {
#line 2224 "window.c"
			GtkToggleButton* _tmp9_;
			GtkBox* _tmp10_;
#line 270 "../src/window.vala"
			_tmp9_ = self->priv->earmark_mode_button;
#line 270 "../src/window.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp9_, !self->priv->window_width_is_small);
#line 271 "../src/window.vala"
			_tmp10_ = self->priv->clock_box;
#line 271 "../src/window.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp10_, !self->priv->window_width_is_small);
#line 272 "../src/window.vala"
			sudoku_window_display_pause_button (self);
#line 2237 "window.c"
		} else {
			GtkBox* _tmp11_;
			GtkToggleButton* _tmp12_;
			GtkButton* _tmp13_;
#line 276 "../src/window.vala"
			_tmp11_ = self->priv->clock_box;
#line 276 "../src/window.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp11_, FALSE);
#line 277 "../src/window.vala"
			_tmp12_ = self->priv->earmark_mode_button;
#line 277 "../src/window.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp12_, TRUE);
#line 278 "../src/window.vala"
			_tmp13_ = self->priv->play_pause_button;
#line 278 "../src/window.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp13_, FALSE);
#line 2254 "window.c"
		}
	}
#line 260 "../src/window.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_window_properties[SUDOKU_WINDOW_SHOW_TIMER_PROPERTY]);
#line 2259 "window.c"
}

static void
sudoku_window_class_init (SudokuWindowClass * klass,
                          gpointer klass_data)
{
#line 26 "../src/window.vala"
	sudoku_window_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/window.vala"
	g_type_class_adjust_private_offset (klass, &SudokuWindow_private_offset);
#line 26 "../src/window.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) sudoku_window_real_size_allocate;
#line 26 "../src/window.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_window_real_dispose;
#line 26 "../src/window.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_window_get_property;
#line 26 "../src/window.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_window_set_property;
#line 26 "../src/window.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_window_finalize;
#line 26 "../src/window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_WINDOW_SETTINGS_PROPERTY, sudoku_window_properties[SUDOKU_WINDOW_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_WINDOW_VIEW_PROPERTY, sudoku_window_properties[SUDOKU_WINDOW_VIEW_PROPERTY] = g_param_spec_object ("view", "view", "view", TYPE_SUDOKU_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY, sudoku_window_properties[SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY] = g_param_spec_enum ("current-screen", "current-screen", "current-screen", TYPE_SUDOKU_WINDOW_SCREEN, SUDOKU_WINDOW_SCREEN_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_WINDOW_SHOW_TIMER_PROPERTY, sudoku_window_properties[SUDOKU_WINDOW_SHOW_TIMER_PROPERTY] = g_param_spec_boolean ("show-timer", "show-timer", "show-timer", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Sudoku/ui/sudoku-window.ui");
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "windowtitle", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, windowtitle));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "headerbar", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, headerbar));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "game_box", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, game_box));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "start_box", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, start_box));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "start_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, start_button));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "custom_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, custom_check));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "easy_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, easy_check));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "medium_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, medium_check));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "hard_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, hard_check));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "very_hard_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, very_hard_check));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "main_menu", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, main_menu));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "earmark_mode_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, earmark_mode_button));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "undo_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, undo_button));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "redo_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, redo_button));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "back_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, back_button));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "unfullscreen_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, unfullscreen_button));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "play_custom_game_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, play_custom_game_button));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "play_pause_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, play_pause_button));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "toggle_fullscreen_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, toggle_fullscreen_button));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "clock_box", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, clock_box));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "clock_label", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, clock_label));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "start_game_cb", G_CALLBACK(_sudoku_window_start_game_cb_gtk_button_clicked));
#line 158 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_n, GDK_CONTROL_MASK, "app.new-game", NULL, NULL);
#line 159 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_p, GDK_CONTROL_MASK, "app.print-current-board", NULL, NULL);
#line 160 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_p, GDK_NO_MODIFIER_MASK, "app.pause", NULL, NULL);
#line 161 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_r, GDK_CONTROL_MASK, "app.reset-board", NULL, NULL);
#line 162 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_u, GDK_NO_MODIFIER_MASK, "app.undo", NULL, NULL);
#line 163 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_z, GDK_CONTROL_MASK, "app.undo", NULL, NULL);
#line 164 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_r, GDK_NO_MODIFIER_MASK, "app.redo", NULL, NULL);
#line 165 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_z, GDK_CONTROL_MASK | GDK_SHIFT_MASK, "app.redo", NULL, NULL);
#line 166 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_e, GDK_NO_MODIFIER_MASK, "app.earmark-mode", NULL, NULL);
#line 167 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_question, GDK_CONTROL_MASK, "app.shortcuts-window", NULL, NULL);
#line 168 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_comma, GDK_CONTROL_MASK, "app.preferences-dialog", NULL, NULL);
#line 169 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_f, GDK_NO_MODIFIER_MASK, "app.toggle-fullscreen", NULL, NULL);
#line 170 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_F11, GDK_NO_MODIFIER_MASK, "app.toggle-fullscreen", NULL, NULL);
#line 171 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_h, GDK_CONTROL_MASK, "app.highlighter", NULL, NULL);
#line 172 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_w, GDK_CONTROL_MASK, "app.show-warnings", NULL, NULL);
#line 173 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_0, GDK_CONTROL_MASK, "app.zoom-reset", NULL, NULL);
#line 174 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_0, GDK_CONTROL_MASK, "app.zoom-reset", NULL, NULL);
#line 175 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_plus, GDK_CONTROL_MASK, "app.zoom-in", NULL, NULL);
#line 176 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_equal, GDK_CONTROL_MASK, "app.zoom-in", NULL, NULL);
#line 177 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Add, GDK_CONTROL_MASK, "app.zoom-in", NULL, NULL);
#line 178 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_ZoomIn, GDK_NO_MODIFIER_MASK, "app.zoom-in", NULL, NULL);
#line 179 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_minus, GDK_CONTROL_MASK, "app.zoom-out", NULL, NULL);
#line 180 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Subtract, GDK_CONTROL_MASK, "app.zoom-out", NULL, NULL);
#line 181 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_ZoomOut, GDK_NO_MODIFIER_MASK, "app.zoom-out", NULL, NULL);
#line 2382 "window.c"
}

static void
sudoku_window_instance_init (SudokuWindow * self,
                             gpointer klass)
{
#line 26 "../src/window.vala"
	self->priv = sudoku_window_get_instance_private (self);
#line 70 "../src/window.vala"
	self->priv->game = NULL;
#line 78 "../src/window.vala"
	self->priv->_view = NULL;
#line 79 "../src/window.vala"
	self->priv->_current_screen = SUDOKU_WINDOW_SCREEN_NONE;
#line 26 "../src/window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2399 "window.c"
}

static void
sudoku_window_finalize (GObject * obj)
{
	SudokuWindow * self;
#line 26 "../src/window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_WINDOW, SudokuWindow);
#line 70 "../src/window.vala"
	_g_object_unref0 (self->priv->game);
#line 72 "../src/window.vala"
	_g_object_unref0 (self->priv->button_controller);
#line 73 "../src/window.vala"
	_g_object_unref0 (self->priv->backwards_controller);
#line 74 "../src/window.vala"
	_g_object_unref0 (self->priv->forwards_controller);
#line 75 "../src/window.vala"
	_g_object_unref0 (self->priv->scroll_controller);
#line 77 "../src/window.vala"
	_g_object_unref0 (self->priv->_settings);
#line 78 "../src/window.vala"
	_g_object_unref0 (self->priv->_view);
#line 26 "../src/window.vala"
	G_OBJECT_CLASS (sudoku_window_parent_class)->finalize (obj);
#line 2424 "window.c"
}

static GType
sudoku_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuWindow), 0, (GInstanceInitFunc) sudoku_window_instance_init, NULL };
	GType sudoku_window_type_id;
	sudoku_window_type_id = g_type_register_static (adw_application_window_get_type (), "SudokuWindow", &g_define_type_info, 0);
	SudokuWindow_private_offset = g_type_add_instance_private (sudoku_window_type_id, sizeof (SudokuWindowPrivate));
	return sudoku_window_type_id;
}

GType
sudoku_window_get_type (void)
{
	static volatile gsize sudoku_window_type_id__once = 0;
	if (g_once_init_enter (&sudoku_window_type_id__once)) {
		GType sudoku_window_type_id;
		sudoku_window_type_id = sudoku_window_get_type_once ();
		g_once_init_leave (&sudoku_window_type_id__once, sudoku_window_type_id);
	}
	return sudoku_window_type_id__once;
}

static void
_vala_sudoku_window_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	SudokuWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_WINDOW, SudokuWindow);
#line 26 "../src/window.vala"
	switch (property_id) {
#line 26 "../src/window.vala"
		case SUDOKU_WINDOW_SETTINGS_PROPERTY:
#line 26 "../src/window.vala"
		g_value_set_object (value, sudoku_window_get_settings (self));
#line 26 "../src/window.vala"
		break;
#line 26 "../src/window.vala"
		case SUDOKU_WINDOW_VIEW_PROPERTY:
#line 26 "../src/window.vala"
		g_value_set_object (value, sudoku_window_get_view (self));
#line 26 "../src/window.vala"
		break;
#line 26 "../src/window.vala"
		case SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY:
#line 26 "../src/window.vala"
		g_value_set_enum (value, sudoku_window_get_current_screen (self));
#line 26 "../src/window.vala"
		break;
#line 26 "../src/window.vala"
		case SUDOKU_WINDOW_SHOW_TIMER_PROPERTY:
#line 26 "../src/window.vala"
		g_value_set_boolean (value, sudoku_window_get_show_timer (self));
#line 26 "../src/window.vala"
		break;
#line 2483 "window.c"
		default:
#line 26 "../src/window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/window.vala"
		break;
#line 2489 "window.c"
	}
}

static void
_vala_sudoku_window_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	SudokuWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_WINDOW, SudokuWindow);
#line 26 "../src/window.vala"
	switch (property_id) {
#line 26 "../src/window.vala"
		case SUDOKU_WINDOW_SETTINGS_PROPERTY:
#line 26 "../src/window.vala"
		sudoku_window_set_settings (self, g_value_get_object (value));
#line 26 "../src/window.vala"
		break;
#line 26 "../src/window.vala"
		case SUDOKU_WINDOW_VIEW_PROPERTY:
#line 26 "../src/window.vala"
		sudoku_window_set_view (self, g_value_get_object (value));
#line 26 "../src/window.vala"
		break;
#line 26 "../src/window.vala"
		case SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY:
#line 26 "../src/window.vala"
		sudoku_window_set_current_screen (self, g_value_get_enum (value));
#line 26 "../src/window.vala"
		break;
#line 26 "../src/window.vala"
		case SUDOKU_WINDOW_SHOW_TIMER_PROPERTY:
#line 26 "../src/window.vala"
		sudoku_window_set_show_timer (self, g_value_get_boolean (value));
#line 26 "../src/window.vala"
		break;
#line 2527 "window.c"
		default:
#line 26 "../src/window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/window.vala"
		break;
#line 2533 "window.c"
	}
}

static GType
sudoku_window_screen_get_type_once (void)
{
	static const GEnumValue values[] = {{SUDOKU_WINDOW_SCREEN_NONE, "SUDOKU_WINDOW_SCREEN_NONE", "none"}, {SUDOKU_WINDOW_SCREEN_PLAY, "SUDOKU_WINDOW_SCREEN_PLAY", "play"}, {SUDOKU_WINDOW_SCREEN_CREATE, "SUDOKU_WINDOW_SCREEN_CREATE", "create"}, {SUDOKU_WINDOW_SCREEN_MENU, "SUDOKU_WINDOW_SCREEN_MENU", "menu"}, {0, NULL, NULL}};
	GType sudoku_window_screen_type_id;
	sudoku_window_screen_type_id = g_enum_register_static ("SudokuWindowScreen", values);
	return sudoku_window_screen_type_id;
}

GType
sudoku_window_screen_get_type (void)
{
	static volatile gsize sudoku_window_screen_type_id__once = 0;
	if (g_once_init_enter (&sudoku_window_screen_type_id__once)) {
		GType sudoku_window_screen_type_id;
		sudoku_window_screen_type_id = sudoku_window_screen_get_type_once ();
		g_once_init_leave (&sudoku_window_screen_type_id__once, sudoku_window_screen_type_id);
	}
	return sudoku_window_screen_type_id__once;
}

